import { MessageObject } from "../types";
import { microSeconds as micro } from "../util";
export declare const microSeconds: typeof micro;
export declare const type = "simulate";
interface ChannelState {
    time: number;
    name: string;
    messagesCallback: ((data: MessageObject) => void) | null;
}
export declare const SIMULATE_DELAY_TIME = 5;
export declare function create(channelName: string): ChannelState;
export declare function close(channelState: ChannelState): void;
export declare function postMessage(channelState: ChannelState, messageJson: MessageObject): Promise<void>;
export declare function onMessage(channelState: ChannelState, fn: (data: MessageObject) => void): void;
export declare function canBeUsed(): boolean;
export declare function averageResponseTime(): number;
export {};
